<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Izg 2018 - 2019, lab 6.: Třetí úkol</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Izg 2018 - 2019, lab 6.
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Třetí úkol<div class="ingroups"><a class="el" href="group__vs.html">Vertex Shader</a> &#124; <a class="el" href="group__fs.html">Fragment Shader</a> &#124; <a class="el" href="group__init.html">Inicializace</a> &#124; <a class="el" href="group__draw.html">Kreslení</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000002">Todo:</a></b></dt><dd>3.1.) Upravte vertex shader. Vašim úkolem je přidat druhý vertex atribut - normálu vrcholu. Dále přidejte dvě výstupní proměnné typu vec3 a zapište do nich pozici a normálu vrcholu ve world-space. Tyto proměnné budete potřebovat pro výpočet osvětlení ve fragment shaderu. Upravujte phongVertexShaderSource proměnnou. </dd></dl>
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000003">Todo:</a></b></dt><dd>3.2.) Upravte fragment shader (proměnná phongFragmentShaderSource). Vašim úkolem je implementovat phongův osvětlovací model. Přidejte dvě vstupní proměnné (typ vec3) stejného názvu, jako nově přidané výstupní proměnné ve vertex shaderu. V jedné obdržíte pozice fragmentu ve world-space. V druhé obdržíte normálu fragmentu ve world-space. Dále přidejte dvě uniformní proměnné (typ vec3) pro pozici kamery a pro pozici světla. Difuzní barvu materiálu nastavte podle zadání konkrétní skupiny cvičení, ptejte se pokud nevíte jak má materiál vypadat Spekulání barvu materiálu nastavte na vec3(1.f,1.f,1.f) - bílá.<br />
 Shininess faktor nastavte na 40.f.<br />
 Předpokládejte, že světlo má bílou barvu.<br />
 Barva se vypočítá podle vzorce dF*dM*dL + sF*sM*sL.<br />
 dM,sM jsou difuzní/spekulární barvy materiálu - vektory.<br />
 dL,sL jsou difuzní/spekulární barvy světla - vektory.<br />
 dF,sF jsou difuzní/spekulární faktory - skaláry.<br />
 dF lze vypočíst pomocí vztahu clamp(dot(N,L),0.f,1.f) - skalární součin a ořez do rozsahu [0,1].<br />
 N je normála fragmentu (nezapomeňte ji normalizovat).<br />
 L je normalizovaný vektor z pozice fragmentu směrem ke světlu.<br />
 sF lze vypočíst pomocí vztahu pow((clamp(dot(R,L),0.f,1.f)),s) - skalární součin, ořez do rozsahu [0,1] a umocnění.<br />
 s je shininess faktor.<br />
 R je odražený pohledový vektor V; R = reflect(V,N).<br />
 V je normalizovaný pohledový vektor z pozice kamery do pozice fragmentu.<br />
 <br />
 Nezapomeňte, že programujete v jazyce GLSL, který zvládá vektorové operace.<br />
 <b>Seznam užitečných funkcí:</b><ul>
<li>dot(x,y) - funkce vrací skalární součin dvou vektorů x,y stejné délky</li>
<li>clamp(x,a,b) - funkce vrací ořezanou hodnotu x do intervalu [a,b]</li>
<li>normalize(x) - funkce vrací normalizovaný vektor x</li>
<li>reflect(I,N) - funkce vrací odražený vektor I podle normály N</li>
<li>pow(x,y) - funkce vrací umocnění x na y - x^y </li>
</ul>
</dd></dl>
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000006">Todo:</a></b></dt><dd>3.3.) Ve funkci <a class="el" href="student_8h.html#ac2adb2ba4e748239b9db4d037584d3cc" title="This function is called at start of application. It should contain initialization of CPU side...">phong_onInit()</a> získejte lokace přidaných uniformních proměnných pro pozici světla a pro pozice kamery. Zapište lokace do příslušných položek ve struktuře <a class="el" href="structPhongVariables.html" title="This structure contains all global variables for this method. ">PhongVariables</a>. Nezapomeňte, že lokace získáte pomocí jména proměnné v jazyce GLSL, které jste udělali v předcházejícím kroku.<br />
 <b>Seznam funkcí, které jistě využijete:</b><ul>
<li>glGetUniformLocation </li>
</ul>
</dd></dl>
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000007">Todo:</a></b></dt><dd>3.4.) Ve funkci <a class="el" href="student_8h.html#ac2adb2ba4e748239b9db4d037584d3cc" title="This function is called at start of application. It should contain initialization of CPU side...">phong_onInit()</a> nastavte druhý vertex atribut pro normálu podobně jako pro pozici. Musíte získat lokaci vstupní proměnné ve vertex shaderu, kterou jste přidali v předcházejícím kroku. Musíte správně nastavit stride a offset - normála nemá nulový offset.<br />
 </dd></dl>
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000010">Todo:</a></b></dt><dd>3.5.) Ve funkci <a class="el" href="student_8h.html#a53ffbb1a271d285abdaf7a029192f47e" title="This function is called every frame and is responsible for drawing. ">phong_onDraw()</a> nahrajte pozici světla a pozici kamery na GPU. Pozice světla a pozice kamery je v proměnných phong.lightPosition a cameraPosition.<br />
 <b>Seznam funkcí, které jistě využijete:</b><ul>
<li>glUniform3f nebo glUniform3fv </li>
</ul>
</dd></dl>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Apr 24 2019 08:37:08 for Izg 2018 - 2019, lab 6. by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
